using System.Globalization;

namespace Upsilon.BaseTypes.Number
{
    public class ScriptNumberDouble : ScriptNumber
    {
        public double Value { get; }
        protected internal override bool IsFloat { get; } = true;

        public ScriptNumberDouble(double value)
        {
            Value = value;
        }

        public override int GetHashCode()
        {
            return Value.GetHashCode();
        }

        public override string ToString()
        {
            return Value.ToString(CultureInfo.InvariantCulture);
        }

        public static implicit operator double(ScriptNumberDouble n)
        {
            return n.Value;
        }

        public override object ToCSharpObject()
        {
            return Value;
        }

        public override System.Type GetCSharpType()
        {
            return typeof(double);
        }
    }
}