using System.Globalization;

namespace Upsilon.BaseTypes.Number
{
    public class ScriptNumberLong : ScriptNumber
    {
        public long Value { get; set; }
        protected internal override bool IsFloat { get; } = false;

        public ScriptNumberLong(long val)
        {
            Value = val;
        }

        public override int GetHashCode()
        {
            return Value.GetHashCode();
        }

        public override string ToString()
        {
            return Value.ToString(CultureInfo.InvariantCulture);
        }

        public static implicit operator long(ScriptNumberLong n)
        {
            if (n == null)
                return 0;
            return n.Value;
        }

        public override object ToCSharpObject()
        {
            return Value;
        }

        public override System.Type GetCSharpType()
        {
            return typeof(long);
        }
    }
}