namespace Upsilon.BaseTypes
{
    internal class ScriptNull : ScriptType
    {

        public override TypeContainer Type => BaseTypes.Type.Nil;
        public override object ToCSharpObject()
        {
            return null;
        }

        public override System.Type GetCSharpType()
        {
            return null;
        }

        public override string ToString()
        {
            return "null";
        }

        protected bool Equals(ScriptNull other)
        {
            return true;
        }

        public override bool Equals(object obj)
        {
            if (obj == null) return true;
            if (ReferenceEquals(this, obj)) return true;
            if (obj.GetType() != this.GetType()) return false;
            return Equals((ScriptNull) obj);
        }
    }
}