using System.Collections.Generic;
using System.Linq;
using Upsilon.Evaluator;

namespace Upsilon.BaseTypes.ScriptTable
{
    public class GenericKeyedScriptTable : ScriptTable
    {
        public GenericKeyedScriptTable(EvaluationScope scope) : base(scope)
        {

        }

        public override System.Type GetCSharpType()
        {
            return typeof(Dictionary<string, object>);
        }

        public override object ToCSharpObject()
        {
            return EvaluationScope.Variables.ToDictionary(x => x.Key, x => x.Value.ToCSharpObject());
        }

        public override IEnumerator<ScriptType> GetScriptEnumerator()
        {
            foreach (var variable in EvaluationScope.Variables)
            {
                yield return variable.Key.ToScriptType();
            }
        }
    }
}