using System.Linq;

namespace Upsilon.BaseTypes.UserData
{
    public struct UserDataMethodKey
    {
        public UserDataMethodKey(string name, System.Type[] parameterTypes)
        {
            Name                = name;
            ParameterTypeHashes = parameterTypes.Select(x => x.GetHashCode()).ToArray();
        }

        public UserDataMethodKey(string name, int[] parameterTypeHashes)
        {
            Name                = name;
            ParameterTypeHashes = parameterTypeHashes;
        }

        public string Name { get; }
        public int[] ParameterTypeHashes { get; }
    }
}