using System.Collections;
using System.Collections.Generic;
using Upsilon.BaseTypes;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundBinaryExpression : BoundExpression
    {
        public BoundBinaryExpression(BoundBinaryOperator op, BoundExpression leftExpression,
            BoundExpression rightExpression, Type type, TextSpan span) : base(span)
        {
            Operator = op;
            LeftExpression = leftExpression;
            RightExpression = rightExpression;
            Type = type;
        }

        public override BoundKind Kind => BoundKind.BoundBinaryExpression;
        public override IEnumerable<BoundNode> GetChildren()
        {
            yield return LeftExpression;
            yield return RightExpression;
        }

        public override TypeContainer Type { get; }

        public BoundBinaryOperator Operator { get; }
        public BoundExpression LeftExpression { get; }
        public BoundExpression RightExpression { get; }
    }
}