using System.Collections.Generic;
using System.Collections.Immutable;
using Upsilon.BaseTypes;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundFunctionCallExpression : BoundExpression
    {
        public BoundExpression Identifier { get; }
        public ImmutableArray<BoundExpression> Parameters { get; }

        public BoundFunctionCallExpression(BoundExpression identifier, ImmutableArray<BoundExpression> parameters,
            TextSpan span, TypeContainer type) : base(span)
        {
            Identifier = identifier;
            Parameters = parameters;
            Type = type;
        }

        public override BoundKind Kind => BoundKind.BoundFunctionCallExpression;

        public override IEnumerable<BoundNode> GetChildren()
        {
            yield return Identifier;
            foreach (var parameter in Parameters)
            {
                yield return parameter;
            }
        }

        public override TypeContainer Type { get; }
    }
}