using System.Collections.Generic;
using Upsilon.BaseTypes;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundLiteralExpression : BoundExpression
    {
        public BoundLiteralExpression(ScriptType value, TextSpan span) : base(span)
        {
            Value = value;
        }

        public override BoundKind Kind => BoundKind.BoundLiteralExpression;

        public override IEnumerable<BoundNode> GetChildren()
        {
            yield break;
        }

        public override TypeContainer Type => Value.Type;
        public ScriptType Value { get; }
    }
}