using System.Collections.Generic;
using Upsilon.BaseTypes;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundUnaryExpression : BoundExpression
    {
        public override BoundKind Kind => BoundKind.BoundUnaryExpression;

        public override IEnumerable<BoundNode> GetChildren()
        {
            yield return InExpression;
        }

        public override TypeContainer Type { get; }

        public BoundUnaryExpression(BoundUnaryOperator op, BoundExpression inExpression, Type type, TextSpan span) : base(span)
        {
            Operator        = op;
            InExpression = inExpression;
            Type            = type;
        }

        public BoundExpression InExpression { get; }
        public BoundUnaryOperator Operator { get; }
    }
}