using System;
using System.Collections.Generic;
using Upsilon.BaseTypes;
using Upsilon.Text;
using Type = Upsilon.BaseTypes.Type;

namespace Upsilon.Binder
{
    public class BoundVariableExpression : BoundExpression
    {
        public BoundVariableExpression(BoundVariableSymbol variable, TextSpan span) : base(span)
        {
            Variable = variable;
        }

        public BoundVariableSymbol Variable { get; }
        public override BoundKind Kind => BoundKind.VariableExpression;

        public override IEnumerable<BoundNode> GetChildren()
        {
            yield break;
        }

        public override TypeContainer      Type => Variable.Type;
    }
}