using System.Collections.Generic;
using System.Collections.Immutable;
using System.Linq;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundBlockStatement : BoundStatement
    {
        public BoundBlockStatement(ImmutableArray<BoundStatement> statements, TextSpan span) : base(span)
        {
            Statements = statements;
        }

        public override BoundKind Kind => BoundKind.BoundBlockStatement;

        public override IEnumerable<BoundNode> GetChildren()
        {
            return Statements;
        }

        public ImmutableArray<BoundStatement> Statements { get; }
    }
}