using System.Collections.Generic;
using Upsilon.Binder.VariableSymbols;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundFunctionAssignmentStatement : BoundStatement
    {
        public VariableSymbol          Variable { get; }
        public BoundFunctionExpression Func     { get; }

        public BoundFunctionAssignmentStatement(VariableSymbol variable, BoundFunctionExpression func, TextSpan span): base(span)
        {
            Variable = variable;
            Func     = func;
        }

        public override BoundKind Kind => BoundKind.BoundFunctionAssignmentStatement;

        public override IEnumerable<BoundNode> GetChildren()
        {
            yield return Func;
        }
    }
}