using System.Collections.Generic;
using System.Collections.Immutable;
using Upsilon.Binder.VariableSymbols;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundGenericForStatement : BoundStatement
    {
        public ImmutableArray<BoundVariableSymbol> Variables { get; }
        public BoundExpression BoundEnumerableExpression { get; }
        public BoundStatement Block { get; }

        public BoundGenericForStatement(ImmutableArray<BoundVariableSymbol> variables,
        BoundExpression boundEnumerableExpression, BoundStatement block, TextSpan span) : base(span)
        {
            Variables = variables;
            BoundEnumerableExpression = boundEnumerableExpression;
            Block = block;
        }

        public override BoundKind Kind => BoundKind.BoundGenericForStatement;

        public override IEnumerable<BoundNode> GetChildren()
        {
            foreach (var variable in Variables)
            {
                yield return variable;
            }
            yield return BoundEnumerableExpression;
            yield return Block;
        }
    }
}