using System.Collections.Generic;
using Upsilon.Binder.VariableSymbols;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundNumericForStatement : BoundStatement
    {
        public VariableSymbol Variable { get; }
        public BoundExpression BoundStart { get; }
        public BoundExpression BoundStop { get; }
        public BoundExpression BoundStep { get; }
        public BoundBlockStatement Block { get; }

        public BoundNumericForStatement(VariableSymbol variable, BoundExpression boundStart,
            BoundExpression boundStop, BoundExpression boundStep, BoundBlockStatement block, TextSpan span) : base(span)
        {
            Variable = variable;
            BoundStart = boundStart;
            BoundStop = boundStop;
            BoundStep = boundStep;
            Block = block;
        }

        public override BoundKind Kind => BoundKind.BoundNumericForStatement;

        public override IEnumerable<BoundNode> GetChildren()
        {
            yield return BoundStart;
            yield return BoundStop;
            yield return BoundStep;
            yield return Block;
        }
    }
}