using System.Collections.Generic;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundTableAssigmentStatement : BoundStatement
    {
        public BoundExpression TableIndexExpression { get; }
        public BoundExpression Value { get; }

        public BoundTableAssigmentStatement(BoundExpression tableIndexExpression, BoundExpression value,
            TextSpan span) : base(span)
        {
            TableIndexExpression = tableIndexExpression;
            Value = value;
        }

        public override BoundKind Kind => BoundKind.BoundTableAssigmentStatement;

        public override IEnumerable<BoundNode> GetChildren()
        {
            yield return TableIndexExpression;
            yield return Value;
        }
    }
}