using System.Collections.Generic;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class BoundVariableAssignment : BoundStatement
    {
        public BoundVariableSymbol Variable { get; }
        public BoundExpression BoundExpression { get; }
        public bool IsLocalDefinition { get; }

        public BoundVariableAssignment(BoundVariableSymbol variable, BoundExpression boundExpression, bool isLocalDefinition,
            TextSpan span) : base(span)
        {
            Variable = variable;
            BoundExpression = boundExpression;
            IsLocalDefinition = isLocalDefinition;
        }

        public override BoundKind Kind => BoundKind.BoundAssignmentStatement;

        public override IEnumerable<BoundNode> GetChildren()
        {
            yield return BoundExpression;
        }
    }
}