using System;
using System.Collections.Generic;
using Upsilon.Text;

namespace Upsilon.Binder
{
    internal class BoundWhileStatement : BoundStatement
    {
        public BoundExpression Condition { get; }
        public BoundStatement Block { get; }

        public BoundWhileStatement(BoundExpression condition, BoundStatement block, TextSpan eSpan)
        :base(eSpan)
        {
            Condition = condition;
            Block = block;
        }

        public override BoundKind Kind => BoundKind.BoundWhileStatement;

        public override IEnumerable<BoundNode> GetChildren()
        {
            yield return Condition;
            yield return Block;
        }
    }
}