using System.Collections.Generic;
using System.Collections.Immutable;
using Upsilon.BaseTypes;
using Upsilon.Parser;
using Upsilon.Text;

namespace Upsilon.Binder
{
    public class UnboundFunctionExpression : BoundFunctionExpression
    {
        public UnboundFunctionExpression(ImmutableArray<BoundVariableSymbol> parameters,
            BlockStatementSyntax unboundBlock, TextSpan span, BoundScope scope, string name)
            : base(parameters, null, span, scope, BaseTypes.Type.Unknown)
        {
            UnboundBlock = unboundBlock;
            Name = name;
        }

        public string Name { get; }
        public override BoundKind Kind => BoundKind.BoundPromise;

        public BlockStatementSyntax UnboundBlock { get; }

    }
}