using System.Collections.Generic;
using Upsilon.BaseTypes;

namespace Upsilon.Binder.VariableSymbols
{
    public class TableVariableSymbol : VariableSymbol
    {
        public Dictionary<string, VariableSymbol> Variables { get; }
        public bool ContentAware { get; }
        public TableVariableSymbol(string name, bool local, Dictionary<string, VariableSymbol> variables,
            TypeContainer type)
            :base (name, type, local)
        {
            Variables    = variables;
            ContentAware = true;
        }

        public TableVariableSymbol(string name, bool local, TypeContainer type)
            :base (name, type, local)
        {
            Variables    = new Dictionary<string, VariableSymbol>();
            ContentAware = false;
        }
    }
}