using System.Collections.Generic;
using Upsilon.Text;

namespace Upsilon.Parser
{
    public sealed class BinaryExpressionSyntax : ExpressionSyntax
    {
        public BinaryExpressionSyntax(ExpressionSyntax left, SyntaxToken @operator, ExpressionSyntax right)
        {
            Left = left;
            Operator = @operator;
            Right = right;
            Span = TextSpan.Between(left.Span, right.Span);
        }

        public override SyntaxKind Kind => SyntaxKind.BinaryExpression;

        public ExpressionSyntax Left { get; }
        public SyntaxToken Operator { get; }
        public ExpressionSyntax Right { get; }

        public override IEnumerable<SyntaxNode> ChildNodes()
        {
            yield return Left;
            yield return Operator;
            yield return Right;
        }
    }
}