using System.Collections.Generic;

namespace Upsilon.Parser
{
    public sealed class LiteralExpressionSyntax : ExpressionSyntax
    {
        public LiteralExpressionSyntax(SyntaxToken literal, object value)
        {
            Literal = literal;
            Value = value;
            Span = literal.Span;
        }

        public override SyntaxKind Kind => SyntaxKind.LiteralExpression;
        public SyntaxToken Literal { get; }
        public object Value { get; }

        public override IEnumerable<SyntaxNode> ChildNodes()
        {
            yield return Literal;
        }
    }
}