using System.Collections.Generic;
using Upsilon.Text;

namespace Upsilon.Parser
{
    public class IdentifierToken : SyntaxToken
    {
        public IdentifierToken(string name, TextSpan position)
            : base(SyntaxKind.Identifier, position, name, null)
        {
            Name = name;
        }

        public string Name { get; }
        public override SyntaxKind Kind => SyntaxKind.Identifier;
        public override IEnumerable<SyntaxNode> ChildNodes()
        {
            yield break;
        }
    }
}