using System.Collections.Generic;
using Upsilon.Text;

namespace Upsilon.Parser
{
    public class ParameterToken : SyntaxNode
    {
        public ParameterToken(IdentifierToken typeName, IdentifierToken identifierName)
        {
            TypeName = typeName;
            IdentifierName = identifierName;
            var start = identifierName.Span;
            if (typeName != null) start = typeName.Span;
            Span = TextSpan.Between(start, identifierName.Span);
        }

        public IdentifierToken TypeName { get; }
        public IdentifierToken IdentifierName { get; }

        public override SyntaxKind Kind => SyntaxKind.Parameter;
        public override IEnumerable<SyntaxNode> ChildNodes()
        {
            yield return TypeName;
            yield return IdentifierName;
        }
    }
}