using System.Collections.Generic;
using Upsilon.Text;

namespace Upsilon.Parser
{
    public sealed class AssignmentStatementSyntax : StatementSyntax
    {
        public AssignmentStatementSyntax(SyntaxToken localToken, ExpressionSyntax identifyExpression, SyntaxToken equalsToken,
            ExpressionSyntax expression)
        {
            LocalToken = localToken;
            Identifier  = identifyExpression;
            EqualsToken = equalsToken;
            Expression  = expression;
            var start = LocalToken?.Span ?? Identifier.Span;
            Span = TextSpan.Between(start, expression.Span);
        }

        public override SyntaxKind Kind => SyntaxKind.AssignmentStatement;

        public SyntaxToken LocalToken { get; }
        public ExpressionSyntax      Identifier { get; }
        public SyntaxToken EqualsToken { get; }
        public ExpressionSyntax Expression { get; }
        public string[] CommentData { get; set; }

        public override IEnumerable<SyntaxNode> ChildNodes()
        {
            yield return Identifier;
            yield return Expression;
        }
    }
}