using System.Collections.Generic;

namespace Upsilon.Parser
{
    public class BreakStatementSyntax : StatementSyntax
    {
        public SyntaxToken BreakKeyword { get; }
        public BreakStatementSyntax(SyntaxToken breakKeyword)
        {
            BreakKeyword = breakKeyword;
            Span = breakKeyword.Span;
        }

        public override SyntaxKind Kind => SyntaxKind.BreakStatement;
        public override IEnumerable<SyntaxNode> ChildNodes()
        {
            yield return BreakKeyword;
        }
    }
}