using System.Collections.Generic;
using Upsilon.Text;

namespace Upsilon.Parser
{
    public class ReturnStatementSyntax : StatementSyntax
    {
        public ReturnStatementSyntax(SyntaxToken returnToken, ExpressionSyntax expression)
        {
            ReturnToken = returnToken;
            Expression = expression;
            var end = returnToken.Span;
            if (expression != null) end = expression.Span;
            Span = TextSpan.Between(returnToken.Span, end);
        }

        public SyntaxToken ReturnToken { get; }
        public ExpressionSyntax Expression { get; }
        public override SyntaxKind Kind => SyntaxKind.ReturnStatement;
        public override IEnumerable<SyntaxNode> ChildNodes()
        {
            yield return Expression;
        }
    }
}