using System.Collections.Generic;
using Upsilon.Text;

namespace Upsilon.Parser
{
    public class TableAssigmentStatementSyntax : StatementSyntax
    {
        public ExpressionSyntax TableExpression { get; }
        public SyntaxToken      AssignmentToken { get; }
        public ExpressionSyntax Expression      { get; }

        public TableAssigmentStatementSyntax(ExpressionSyntax tableExpression, SyntaxToken assignmentToken,
            ExpressionSyntax expression)
        {
            TableExpression = tableExpression;
            AssignmentToken = assignmentToken;
            Expression      = expression;
            Span = TextSpan.Between(tableExpression.Span, expression.Span);
        }

        public override SyntaxKind Kind => SyntaxKind.TableAssignmentStatement;

        public override IEnumerable<SyntaxNode> ChildNodes()
        {
            yield return TableExpression;
            yield return AssignmentToken;
            yield return Expression;
        }
    }
}