using System;
using System.Collections.Generic;
using Upsilon.Text;

namespace Upsilon.Parser
{
    internal class WhileStatementSyntax : StatementSyntax
    {
        public SyntaxToken WhileToken { get; }
        public ExpressionSyntax Expression { get; }
        public SyntaxToken DoToken { get; }
        public StatementSyntax Block { get; }
        public SyntaxToken EndKeyword { get; }

        public WhileStatementSyntax(SyntaxToken whileToken, ExpressionSyntax expression, SyntaxToken doToken,
            StatementSyntax block, SyntaxToken endKeyword)
        {
            WhileToken = whileToken;
            Expression = expression;
            DoToken = doToken;
            Block = block;
            EndKeyword = endKeyword;

            Span = TextSpan.Between(whileToken.Span, endKeyword.Span);
        }

        public override SyntaxKind Kind => SyntaxKind.WhileStatement;
        public override IEnumerable<SyntaxNode> ChildNodes()
        {
            yield return WhileToken;
            yield return Expression;
            yield return DoToken;
            yield return Block;
            yield return EndKeyword;
        }
    }
}