namespace Upsilon.Parser
{
    public static class SyntaxKeyWords
    {
        public static SyntaxKind GetSyntaxKind(string s)
        {
            switch (s)
            {
                case "true":
                    return SyntaxKind.TrueKeyword;
                case "false":
                    return SyntaxKind.FalseKeyword;
                case "not":
                    return SyntaxKind.NotKeyword;
                case "and":
                    return SyntaxKind.AndKeyword;
                case "or":
                    return SyntaxKind.OrKeyword;
                case "local":
                    return SyntaxKind.LocalKeyword;
                case "end":
                    return SyntaxKind.EndKeyword;
                case "if":
                    return SyntaxKind.IfKeyword;
                case "then":
                    return SyntaxKind.ThenKeyword;
                case "elseif":
                    return SyntaxKind.ElseIfKeyword;
                case "else":
                    return SyntaxKind.ElseKeyword;
                case "nil":
                    return SyntaxKind.NilKeyword;
                case "function":
                    return SyntaxKind.FunctionKeyword;
                case "return":
                    return SyntaxKind.ReturnKeyword;
                case "for":
                    return SyntaxKind.ForKeyword;
                case "while":
                    return SyntaxKind.WhileKeyword;
                case "in":
                    return SyntaxKind.InKeyword;
                case "do":
                    return SyntaxKind.DoKeyword;
                case "break":
                    return SyntaxKind.BreakKeyword;
                default:
                    return SyntaxKind.Identifier;
            }
        }
    }
}