using System.Collections.Generic;
using Upsilon.Text;

namespace Upsilon.Parser
{
    public class SyntaxToken : SyntaxNode
    {
        public SyntaxToken(SyntaxKind kind, TextSpan position, string text, object value)
        {
            Kind  = kind;
            Span  = position;
            Value = value;
        }

        public SyntaxToken(SyntaxKind kind, TextSpan position, int length, object value)
        {
            Kind  = kind;
            Span  = position;
            Value = value;
        }

        public override SyntaxKind Kind { get; }
        public object Value { get; }
        public string[] CommentData { get; set; }

        public override IEnumerable<SyntaxNode> ChildNodes()
        {
            yield break;
        }
    }

    public class ReturnSyntaxToken : SyntaxToken
    {
        public bool FollowedByLineBreak { get; }

        public ReturnSyntaxToken(TextSpan position, bool followedByLineBreak)
            : base(SyntaxKind.ReturnKeyword, position, "return", null)
        {
            FollowedByLineBreak = followedByLineBreak;
        }
    }
}