using Upsilon.BaseTypes;
using Upsilon.BaseTypes.ScriptTypeInterfaces;

namespace Upsilon.StandardLibraries
{
    internal class ListLibrary
    {
        [ScriptFunction("contains", "Returns a boolean that defines whether a table contains a value", directScriptManipulation: true)]
        public ScriptBoolean Contains(IIterable table, ScriptType obj)
        {
            var enumerator = table.GetScriptEnumerator();
            while (enumerator.MoveNext())
            {
                var current = enumerator.Current;
                if (current == obj)
                    return true;
            }
            return false;
        }
    }
}