using Upsilon;
using Upsilon.Binder;
using Upsilon.Evaluator;
using Upsilon.StandardLibraries;
using Xunit;

namespace UpsilonTests.GeneralTests
{
    public class LengthOperatorTests : TestClass
    {
        public LengthOperatorTests(StaticScriptFixture fix) : base(fix)
        {
        }

        [Theory]
        [InlineData(@"#""test""", 4)]
        [InlineData(@"#{100,50,60,7863,1564,12354,10354}", 7)]
        public void Test(string input, long expectedOutput)
        {
            var actual = Executor.EvaluateScript<long>(input, Options);
            Assert.Equal(expectedOutput, actual);
        }

    }
}